//----------------------------------------------------------------------
// Prozessor : ATmega32
// Sprache   : C
// Datum     : 16.06.2011
// Version   : 1.0
// Autor     : Thilo M.
// Programm  : Messung mit internem 10-bit-ADC
//----------------------------------------------------------------------

unsigned int ADC_temp;
double ADCerg = 0;

//*** Einstellungen fr AD-Wandler ****************************************************************	
void ADC_init (void)
{	
  ADCSRA |= _BV(ADEN)|		// ADC enable
			_BV(ADIF)|		// Flag lschen
			_BV(ADPS2)|		//
			_BV(ADPS1)|		//
			_BV(ADPS0);		// Prescaler /128 => 16MHz / 128 = 125kHz
  ADMUX &= ~_BV(REFS1)&	// 
			~_BV(REFS0)&	// Referenzspannung
			~_BV(ADLAR)&	// Linksbndiges Ergebnis [0 => Rechtsbndig]
			~_BV(MUX3)&		//
			~_BV(MUX2)&		//
			~_BV(MUX1)&		//
			~_BV(MUX0);		// Multiplexer
}

/**** ADC *****************************************************************************************/

double ADC_conversion(unsigned char mux)		// Spannung messen (100 Messswerte-Mittelwert)
{	
	ADMUX = mux;						// Multiplexer einstellen 
	    
    for(unsigned char i=0;i<100;i++)   // 100 Messungen fr bessere Genauigkeit 
		{
			ADCSRA |= (1<<ADSC);       // 'single conversion' einleiten
			while(!(ADCSRA & 0x10));  	// auf ende der Wandlung warten, ADIF flag '1'
			ADC_temp = ADCL;           	// ADCL Register lesen
			ADC_temp += (ADCH << 8);   // ADCH Register lesen      
			ADCerg += ADC_temp;     	// Ergebnisse der 100 Messungen addieren
		}
 	ADCerg = (ADCerg/100);				// 
	return (ADCerg);
}






